<!doctype html>
<html>
<head>
    <title>New alpha release: Tor 0.4.1.2-alpha | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="New alpha release: Tor 0.4.1.2-alpha | Tor Project">
    <meta property="og:description" content="There&#39;s a new alpha release available for download. If you build Tor from source, you can download the source code for 0.4.1.2-alpha from the usual place on the website. Packages should be available over the coming weeks, with a new alpha Tor Browser release by some time next week. Remember, this is an alpha release: you should only run this if you&#39;d like to find and report more bugs than usual. Tor 0.4.1.2-alpha resolves numerous bugs--some of them from the previous alpha, and some much older. It also contains minor testing improvements, and an improvement to the security of our authenticated SENDME implementation. Changes in version 0.4.1.2-alpha - 2019-06-06 Major bugfixes (bridges): Consider our directory information to have changed when our list of bridges changes. Previously, Tor would not re-compute the status of its directory information when bridges changed, and therefore would not realize that it was no longer able to build circuits. Fixes part of bug 29875. Do not count previously configured working bridges towards our total of working bridges. Previously, when Tor&#39;s list of bridges changed, it would think that the old bridges were still usable, and delay fetching router descriptors for the new ones. Fixes part of bug 29875; bugfix on 0.3.0.1-alpha. Major bugfixes (flow control, SENDME): Decrement the stream-level package window after packaging a cell. Previously, it was done inside a log_debug() call, meaning that if debug logs were not enabled, the decrement would never happen, and thus the window would be out of sync with the other end point. Fixes bug 30628; bugfix on 0.4.1.1-alpha.">
    <meta property="og:image" content="https://blog.torproject.org/new-alpha-release-tor-0412-alpha/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/new-alpha-release-tor-0412-alpha/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        New alpha release: Tor 0.4.1.2-alpha
      </h1>
    <p class="meta">by nickm | June 6, 2019</p>
    <picture>
      
      <img class="lead" src="lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>There's a new alpha release available for download. If you build Tor from source, you can download the source code for 0.4.1.2-alpha from <a href="https://www.torproject.org/download/tor/">the usual place on the website</a>. Packages should be available over the coming weeks, with a new alpha Tor Browser release by some time next week.</p>
<p>Remember, this is an alpha release: you should only run this if you'd like to find and report more bugs than usual.</p>
<p>Tor 0.4.1.2-alpha resolves numerous bugs--some of them from the previous alpha, and some much older. It also contains minor testing improvements, and an improvement to the security of our authenticated SENDME implementation.</p>
<h2>Changes in version 0.4.1.2-alpha - 2019-06-06</h2>
<ul>
<li>Major bugfixes (bridges):
<ul>
<li>Consider our directory information to have changed when our list of bridges changes. Previously, Tor would not re-compute the status of its directory information when bridges changed, and therefore would not realize that it was no longer able to build circuits. Fixes part of bug <a href="https://bugs.torproject.org/29875">29875</a>.</li>
<li>Do not count previously configured working bridges towards our total of working bridges. Previously, when Tor's list of bridges changed, it would think that the old bridges were still usable, and delay fetching router descriptors for the new ones. Fixes part of bug <a href="https://bugs.torproject.org/29875">29875</a>; bugfix on 0.3.0.1-alpha.</li>
</ul>
</li>
<li>Major bugfixes (flow control, SENDME):
<ul>
<li>Decrement the stream-level package window after packaging a cell. Previously, it was done inside a log_debug() call, meaning that if debug logs were not enabled, the decrement would never happen, and thus the window would be out of sync with the other end point. Fixes bug <a href="https://bugs.torproject.org/30628">30628</a>; bugfix on 0.4.1.1-alpha.</li>
</ul>
</li>
</ul>
<p> </p>
<!--break--><ul>
<li>Major bugfixes (onion service reachability):
<ul>
<li>Properly clean up the introduction point map and associated state when circuits change purpose from onion service circuits to pathbias, measurement, or other circuit types. This may fix some instances of introduction point failure. Fixes bug <a href="https://bugs.torproject.org/29034">29034</a>; bugfix on 0.3.2.1-alpha.</li>
</ul>
</li>
<li>Minor features (authenticated SENDME):
<ul>
<li>Ensure that there is enough randomness on every circuit to prevent an attacker from successfully predicting the hashes they will need to include in authenticated SENDME cells. At a random interval, if we have not sent randomness already, we now leave some extra space at the end of a cell that we can fill with random bytes. Closes ticket <a href="https://bugs.torproject.org/26846">26846</a>.</li>
</ul>
</li>
<li>Minor features (continuous integration):
<ul>
<li>When running coverage builds on Travis, we now set TOR_TEST_RNG_SEED, to avoid RNG-based coverage differences. Part of ticket <a href="https://bugs.torproject.org/28878">28878</a>.</li>
</ul>
</li>
<li>Minor features (maintenance):
<ul>
<li>Add a new "make autostyle" target that developers can use to apply all automatic Tor style and consistency conversions to the codebase. Closes ticket <a href="https://bugs.torproject.org/30539">30539</a>.</li>
</ul>
</li>
<li>Minor features (testing):
<ul>
<li>The circuitpadding tests now use a reproducible RNG implementation, so that if a test fails, we can learn why. Part of ticket <a href="https://bugs.torproject.org/28878">28878</a>.</li>
<li>Tor's tests now support an environment variable, TOR_TEST_RNG_SEED, to set the RNG seed for tests that use a reproducible RNG. Part of ticket <a href="https://bugs.torproject.org/28878">28878</a>.</li>
<li>When running tests in coverage mode, take additional care to make our coverage deterministic, so that we can accurately track changes in code coverage. Closes ticket <a href="https://bugs.torproject.org/30519">30519</a>.</li>
</ul>
</li>
<li>Minor bugfixes (configuration, proxies):
<ul>
<li>Fix a bug that prevented us from supporting SOCKS5 proxies that want authentication along with configured (but unused!) ClientTransportPlugins. Fixes bug <a href="https://bugs.torproject.org/29670">29670</a>; bugfix on 0.2.6.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (controller):
<ul>
<li>POSTDESCRIPTOR requests should work again. Previously, they were broken if a "purpose=" flag was specified. Fixes bug <a href="https://bugs.torproject.org/30580">30580</a>; bugfix on 0.4.1.1-alpha.</li>
<li>Repair the HSFETCH command so that it works again. Previously, it expected a body when it shouldn't have. Fixes bug <a href="https://bugs.torproject.org/30646">30646</a>; bugfix on 0.4.1.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (developer tooling):
<ul>
<li>Fix pre-push hook to allow fixup and squash commits when pushing to non-upstream git remote. Fixes bug <a href="https://bugs.torproject.org/30286">30286</a>; bugfix on 0.4.0.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (directory authority):
<ul>
<li>Move the "bandwidth-file-headers" line in directory authority votes so that it conforms to dir-spec.txt. Fixes bug <a href="https://bugs.torproject.org/30316">30316</a>; bugfix on 0.3.5.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (NetBSD):
<ul>
<li>Fix usage of minherit() on NetBSD and other platforms that define MAP_INHERIT_{ZERO,NONE} instead of INHERIT_{ZERO,NONE}. Fixes bug <a href="https://bugs.torproject.org/30614">30614</a>; bugfix on 0.4.0.2-alpha. Patch from Taylor Campbell.</li>
</ul>
</li>
<li>Minor bugfixes (out-of-memory handler):
<ul>
<li>When purging the DNS cache because of an out-of-memory condition, try purging just the older entries at first. Previously, we would always purge the whole thing. Fixes bug <a href="https://bugs.torproject.org/29617">29617</a>; bugfix on 0.3.5.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (portability):
<ul>
<li>Avoid crashing in our tor_vasprintf() implementation on systems that define neither vasprintf() nor _vscprintf(). (This bug has been here long enough that we question whether people are running Tor on such systems, but we're applying the fix out of caution.) Fixes bug <a href="https://bugs.torproject.org/30561">30561</a>; bugfix on 0.2.8.2-alpha. Found and fixed by Tobias Stoeckmann.</li>
</ul>
</li>
<li>Minor bugfixes (shutdown, libevent, memory safety):
<ul>
<li>Avoid use-after-free bugs when shutting down, by making sure that we shut down libevent only after shutting down all of its users. We believe these are harmless in practice, since they only occur on the shutdown path, and do not involve any attacker-controlled data. Fixes bug <a href="https://bugs.torproject.org/30629">30629</a>; bugfix on 0.4.1.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (static analysis):
<ul>
<li>Fix several spurious Coverity warnings about the unit tests, to lower our chances of missing real warnings in the future. Fixes bug <a href="https://bugs.torproject.org/30150">30150</a>; bugfix on 0.3.5.1-alpha and various other Tor versions.</li>
</ul>
</li>
<li>Testing:
<ul>
<li>Specify torrc paths (with empty files) when launching tor in integration tests; refrain from reading user and system torrcs. Resolves issue <a href="https://bugs.torproject.org/29702">29702</a>.</li>
</ul>
</li>
</ul>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-282405"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-282405" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">June 08, 2019</p>
    </div>
    <a href="#comment-282405">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-282405" class="permalink" rel="bookmark">Ubuntu problem:
After…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Ubuntu problem:</p>
<p>After libseccomp was updated couple of days ago. my compiled TOR binary can't access .tor directory using mmap()...</p>
<p>The tmp fix is to : add --disable-seccomp in configure</p>
<p>That's BAD</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-282431"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-282431" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  nickm
  </article>
    <div class="comment-header">
      <p class="comment__submitted">nickm said:</p>
      <p class="date-time">June 10, 2019</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-282405" class="permalink" rel="bookmark">Ubuntu problem:
After…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-282431">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-282431" class="permalink" rel="bookmark">Hi! If it&#039;s a broken…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hi! If it's a broken libseccomp issue, you can probably also work around it by setting "Sandbox 0" in your configuration. But presumably you want the sandbox to keep working.  One problem we've been having here is that newer versions of libseccomp seem to regard the ordering of our rules as optional, making it harder to encode the behavior we want (see <a href="https://trac.torproject.org/projects/tor/ticket/29819" rel="nofollow">https://trac.torproject.org/projects/tor/ticket/29819</a> ).</p>
<p>If the comments on the ticket above don't look like the errors you're encoutering, please open a new ticket on trac, and quote the exact error messages you're getting?  Without those, problems like this are hard to debug.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-282411"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-282411" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>brian (not verified)</span> said:</p>
      <p class="date-time">June 09, 2019</p>
    </div>
    <a href="#comment-282411">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-282411" class="permalink" rel="bookmark">hello, since i just…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>hello, since i just downloaded update and even on my phone when i go to a site and try to watch vids that ive watched a couple days ago are now saying no video format or MIME type found. How can i fix this? i need webm file types and mp4 to be able to play. mostly though .webm files.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-282430"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-282430" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  nickm
  </article>
    <div class="comment-header">
      <p class="comment__submitted">nickm said:</p>
      <p class="date-time">June 10, 2019</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-282411" class="permalink" rel="bookmark">hello, since i just…</a> by <span>brian (not verified)</span></p>
    <a href="#comment-282430">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-282430" class="permalink" rel="bookmark">Hi!  It sounds like you&#039;re…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hi!  It sounds like you're having a problem with Tor Browser, not with Tor itself. If it's a bug, your best bet here is to open a ticket on trac.torproject.org under the "Applications / Tor Browser" component.  Best of luck!</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-282468"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-282468" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>GoodFlow (not verified)</span> said:</p>
      <p class="date-time">June 12, 2019</p>
    </div>
    <a href="#comment-282468">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-282468" class="permalink" rel="bookmark">Seems not to break with this…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Seems not to break with this update to flow control!</p>
<p>Thanks</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-282538"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-282538" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">June 17, 2019</p>
    </div>
    <a href="#comment-282538">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-282538" class="permalink" rel="bookmark">I&#039;m sorry if this is…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I'm sorry if this is inappropriate place to ask this question, but I still cannot see a package for tor 0.4.0.5 in tor repos for Debian. Was it ever released? Was it released, but Jessie was excluded? I cannot see it for my Jessie though I use official tor repositories.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-282828"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-282828" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">June 25, 2019</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-282538" class="permalink" rel="bookmark">I&#039;m sorry if this is…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-282828">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-282828" class="permalink" rel="bookmark">similar comment answered here</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p><a href="https://blog.torproject.org/comment/282615#comment-282615" rel="nofollow">similar comment answered here</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
</div>
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
